function MR.events.OnEvent( event, ... )
	if( event == "VARIABLES_LOADED" )then
		MR.events.VariablesLoaded();
	end;
	if( event == "ZONE_CHANGED" )then
	end;
end;

function MR.events.VariablesLoaded()
	local hRet;
	hRet, mRepairVariables = MLib.CheckVariables( mRepairVariables, MR.DefaultConfig );
	if( hRet == MLIB_CHECKVARIABLES_FAILED )then
		MR.Message( "|cffFF0000Ошибка запуска! Исполнение прекращено!|r" );
		MR.PANIC = true;
		return nil;
	end;
	
	if( hRet == MLIB_CHECKVARIABLES_FIRSTSTART )then
		MR.Message( "Первый запуск! Установка параметров по умолчанию." );
		MLib.ListProperties( MR.ConfigNames, mRepairVariables, MR.ShortName );
	end;
	MR.Message( MR.Name .. " " .. MR.Version .. " успешно загружен" );

	SaveVariables( "mRepairVariables" );
	
	MR.stInventory = {
		["HeadSlot"] = -1,
		["HandsSlot"] = -1,
		["FeetSlot"] = -1,
		["ChestSlot"] = -1,
		["LegsSlot"] = -1,
		["BackSlot"] = -1,
		["WaistSlot"] = -1,
		["ShoulderSlot"] = -1,
		["NecklaceSlot"] = -1,
--		["AmmoSlot"] = -1,
		["RangedSlot"] = -1,
		["Ring0Slot"] = -1,
		["Ring1Slot"] = -1,
		["Earring0Slot"] = -1,
		["Earring1Slot"] = -1,
		["MainHandSlot"] = -1,
		["SecondaryHandSlot"] = -1,
		["UtensilSlot"] = -1,
		["Talisman0Slot"] = -1,
		["Talisman1Slot"] = -1,
		["Talisman2Slot"] = -1,
		["AdornmentSlot"] = -1,
	};
	for key, value in pairs( MR.stInventory )do
		local slotID,_ = GetInventorySlotInfo( key );
		MR.stInventory[ key ] = slotID;
	end;
	
	MRBrokenFrame:ClearAllAnchors();
	MRBrokenFrame:SetAnchor( "CENTER", "CENTER", UIParent, 0, -math.floor( UIParent:GetHeight() / 4 ) );
	
	local _scale = GetUIScale();
	MRTalismans:ClearAllAnchors();
	MRTalismans:SetAnchor( "TOPLEFT", "TOPLEFT", UIParent, mRepairVariables.TalismansPositionX / _scale, mRepairVariables.TalismansPositionY / _scale );
	
	MRTalismans_Talisman0:ClearAllAnchors();
	MRTalismans_Talisman0:SetAnchor( "TOPLEFT", "TOPLEFT", MRTalismans, 5, 5 );
	MRTalismans_Talisman1:ClearAllAnchors();
	MRTalismans_Talisman1:SetAnchor( "TOPLEFT", "BOTTOMLEFT", MRTalismans_Talisman0, 0, -8 );
	MRTalismans_Talisman2:ClearAllAnchors();
	MRTalismans_Talisman2:SetAnchor( "TOPLEFT", "BOTTOMLEFT", MRTalismans_Talisman1, 0, -8 );

	MRTalismans_Talisman0StatusBar:ClearAllAnchors();
	MRTalismans_Talisman0StatusBar:SetAnchor( "TOPLEFT", "TOPRIGHT", MRTalismans_Talisman0, -3, 7 );
	MRTalismans_Talisman1StatusBar:ClearAllAnchors();
	MRTalismans_Talisman1StatusBar:SetAnchor( "TOPLEFT", "TOPRIGHT", MRTalismans_Talisman1, -3, 7 );
	MRTalismans_Talisman2StatusBar:ClearAllAnchors();
	MRTalismans_Talisman2StatusBar:SetAnchor( "TOPLEFT", "TOPRIGHT", MRTalismans_Talisman2, -3, 7 );
	
	MR.ui.MRTalismansOnUpdate( nil, 0 );
	
	MR.ui.ReplaceIMBFSlots();
	
	MRVisualDurable:ClearAllAnchors();
	MRVisualDurable:SetAnchor( "TOPLEFT", "TOPLEFT", UIParent, mRepairVariables.DurableFrame.X / _scale, mRepairVariables.DurableFrame.Y / _scale );
	if( mRepairVariables.DurableFrame.Enable )then
		MRVisualDurableAnchor:SetAlpha( 0.2 );
		MRVisualDurable:Show();
		MRVisualDurable:SetAlpha( 0.9 );
	end;
	
	MRConfig.Hammer = mRepairVariables.Hammer;
end;

function MR.events.OnUpdate( this, elapsedTime )
	MR.tools.CheckEquipDurable();
	MR.tools.CheckTalismanDurable();

	if( not mRepairVariables.Enabled )then
		MR.ui.SetState( MR_STATE_DISABLED );
		return nil;
	end;
	
	if( MR.tools.GetBrokenCount() > 0 )then
		MR.ui.SetState( MR_STATE_WARNING );
	else
		MR.ui.SetState( MR_STATE_NORMAL );
	end;

	if( MR.tools.GetBrokenCount() > 0 )and( mRepairVariables.BrokenVisual )then
		MRBrokenFrameTitle:SetText( "Сломано или в критическом состоянии " .. tostring( MR.tools.GetBrokenCount() ) .. " предметов!" );
		if( mRepairVariables.BrokenVisualOneTime )or( MR.Vars.BrokenStep == 0 )then
			MRBrokenFrame:Show();
		end;
	else
		MR.Vars.BrokenStep = 0;
		MRBrokenFrame:Hide();
	end;
	
	if( mRepairVariables.Talismans )and( MR.Talismans ~= nil )then
		for n = 0, 2 do
			if( MR.Talismans[ n ]["max"] > 0 )and( MR.Talismans[ n ]["curr"] >= MR.Talismans[ n ]["max"] )and( not MRTalismanFrame:IsVisible() )then
				if( not MR.Vars.TalismansVisible[ n ] )then
					MRTalismanFrameTitle:SetText( MR.Talismans[ n ]["name"] .. " полон!" );
					MRTalismanFrame:Show();
					MR.Vars.TalismansVisible[ n ] = true;
				end;
			else
				if( MR.Talismans[ n ]["max"] <= 0 )or( MR.Talismans[ n ]["curr"] < MR.Talismans[ n ]["max"] )then
					MR.Vars.TalismansVisible[ n ] = false;
				end;
			end;
		end;
	end;
	
	MR.Vars.LastMessage = MR.Vars.LastMessage + elapsedTime;
	if( math.floor( MR.Vars.LastMessage ) < mRepairVariables.MessageDelay )then return nil; end;
	MR.Vars.LastMessage = -1;

	if( MR.tools.GetBrokenCount() > 0 )and( mRepairVariables.Broken )then
		MR.ui.ShowBrokens();
	end;
	
end;

function MR.events.BrokenOnUpdate(this, elapsedTime)
	if( not MRBrokenFrame:IsVisible() )then return nil; end;
	
	local count = MR.Vars.BrokenStepCount;
	if( mRepairVariables.BrokenVisualOneTime )then count = count * 3; end;
	MRBrokenFrameTitle:SetAlpha( 1 - ( MR.Vars.BrokenStep / count ) );

	MR.Vars.BrokenStep = MR.Vars.BrokenStep + 1;
	if( MR.Vars.BrokenStep > count )then
		if( mRepairVariables.BrokenVisualOneTime )then
			MRBrokenFrame:Hide();
		else
			MR.Vars.BrokenStep = 0;
		end;
	end;
end;

function MR.events.TalismanOnUpdate(this, elapsedTime)
	if( MRTalismanFrame:IsVisible() )then

		MRTalismanFrameTitle:SetFontSize( 10 + MR.Vars.TalismanStep );
		local text = MRTalismanFrameTitle:GetText();
		MRTalismanFrameTitle:SetText( "" );
		MRTalismanFrameTitle:SetText( text );
		
		MRTalismanFrameTitle:SetAlpha( 1 - ( MR.Vars.TalismanStep / MR.Vars.TalismanStepCount ) );
		MR.Vars.TalismanStep = MR.Vars.TalismanStep + 1;
		
		if( MR.Vars.TalismanStep > MR.Vars.TalismanStepCount )then MR.Vars.TalismanStep = 0; MRTalismanFrame:Hide(); end;
	end;
end;

function MR.events.ShowPickerHint( this, name )
	MLib.TT.Init( this, MR.Name .. " " .. MR.Version, 300, "ANCHOR_TOPRIGHT", 0, 0 );
	if( name ~= nil )then
		MLib.TT.Space();
		MLib.TT.Line( name );
		MLib.TT.Space();
	end;
	MLib.TT.Line( "Shift + правая кнопка мыши для перетаскивания", 0, 0.75, 0.95 );
end;

function MR.events.StartMoving( this, key )
	if( IsShiftKeyDown() )and( key == "RBUTTON" )then
		this:GetParent():StartMoving( "TOPLEFT" );
	end;
end;

function MR.events.StopMovingTalismans( this )
	this:GetParent():StopMovingOrSizing();
	mRepairVariables.TalismansPositionX, mRepairVariables.TalismansPositionY = this:GetParent():GetPos();
	SaveVariables( "mRepairVariables" );
end;

function MR.events.EquipIfExists( itemName, slot )
	local _, bagCount = GetBagCount();
	for n = 1, bagCount do
		local _, _, name, _, locked, _ = GetBagItemInfo( n );
		if( name == itemName )and( not locked )then
			PickupBagItem( GetBagItemInfo( n ) );
			MRTalismans:SetID( slot );
			return true;
		end;
	end;
	
	for n = 1, 50 do
		local _, name, _, locked = GetGoodsItemInfo( n );
		if( name == itemName )and( not locked )then
			PickupBagItem( n );
			MRTalismans:SetID( slot );
			return true;
		end;
	end;
	
	return false;
end;

function MR.events.TalismanClick( this, key )
	local stSlots = {
		[18] = EquipTalisman0Slot,
		[19] = EquipTalisman1Slot,
		[20] = EquipTalisman2Slot,
	};
	local _ID = this:GetID();
	if( key == "RBUTTON" )then
		local _, _, itemName, _, _ = GetInventoryItemDurable( "player", _ID );
		EquipItemButton_OnClick( stSlots[ _ID ], "RBUTTON" );
		if( mRepairVariables.EquipNew )then MR.events.EquipIfExists( itemName, _ID ); end;
	end;
end;

function MR.events.DurableAnchorHint( this )
	this:SetAlpha(1);
	MLib.TT.Init( this, MR.Name .. " " .. MR.Version, 300, "ANCHOR_BOTTOMRIGHT", 0, 0 );
	MLib.TT.Space();
	MLib.TT.Line( "Панель прочности" );
	MLib.TT.Space();
	MLib.TT.Line( "Shift + Правая кнопка мыши для перетаскивания", 0, 0.75, 0.95 );
end;

function MR.events.DurableAnchorMouseDown( this, key )
	if( not MLib.ControlsDown( false ) )and( key == "RBUTTON" )then
		this:GetParent():StartMoving( "TOPLEFT" );
		this.IsMoving = true;
	end;
end;

function MR.events.DurableAnchorMouseUp( this )
	if( not this.IsMoving )then return nil; end;
	this:GetParent():StopMovingOrSizing();
	mRepairVariables.DurableFrame.X, mRepairVariables.DurableFrame.Y = this:GetParent():GetPos();
	SaveVariables( "mRepairVariables" );
end;

function MR.events.OnReceiveDrag( this )
	if( CursorItemType() ~= "bag" )then return nil; end;

	local index = GetCursorItemInfo();
	local num = -1;
	for n = 1, 180 do
		if( _G[ "BagItemButton" .. n ].index == index )then
			BagItemButton_OnClick( _G[ "BagItemButton" .. n ], "LBUTTON", 1 );
			num = n;
		end;
	end;
	local _, icon, name, itemCount, locked, quality = GetBagItemInfo( num );
	local link = GetBagItemLink( index, false );
	local r, g, b = MLib.ColorHex2Dec( MLib.Qualities[ quality ]:sub( 5, 10 ) );

	MRConfig.Hammer = {
		["icon"] = icon,
		["quality"] = quality,
		["name"] = name,
		["link"] = link,
	};
	mRepairVariables.Hammer = {
		["icon"] = icon,
		["quality"] = quality,
		["name"] = name,
		["link"] = link,
	};
	
	_G[ this:GetName() .. "Icon" ]:SetTexture( icon );
	local r, g, b = MLib.ColorHex2Dec( MLib.Qualities[ quality ]:sub( 5, 10 ) );
	_G[ this:GetName() .. "Quality" ]:Show();
	_G[ this:GetName() .. "Quality" ]:SetColor( r, g, b );
	_G[ this:GetName() .. "Text" ]:SetText( name );
end;

function MR.events.UseHammer( this )
	for n = 1, 180 do
		local link = GetBagItemLink( GetBagItemInfo( n ) );
		if( MLib.itemID( link ) == MLib.itemID( mRepairVariables.Hammer.link ) )then
			BagItemButton_OnClick( _G[ "BagItemButton" .. n ], "RBUTTON", 1 );
			return nil;
		end;
	end;
end;

function MR.events.HammerOnUpdate( this, elapsedTime )
	if( this.Time == nil )then this.Time = 0; end;
	this.Time = this.Time + elapsedTime;
	if( this.Time < 0.5 )then return nil; end;
	this.Time = 0;
	
	_G[ this:GetName() .. "Icon" ]:SetTexture( mRepairVariables.Hammer.icon );
	local r, g, b = MLib.ColorHex2Dec( MLib.Qualities[ mRepairVariables.Hammer.quality ]:sub( 5, 10 ) );
	_G[ this:GetName() .. "Quality" ]:Show();
	_G[ this:GetName() .. "Quality" ]:SetColor( r, g, b );
	_G[ this:GetName() .. "Text" ]:SetText( "" );
end;

-- /run dofile("Interface/AddOns/mRepair/code/events.lua");