MR.ui.Vars = {
	["Enabled"] = "Включить/выключить",
	["Broken"] = "Сообщения о сломанных вещах",
	["Talismans"] = "Сообщения об амулетах",
	["BrokenVisual"] = "Визуально о поломках",
	["BrokenChats"] = "Во все чаты",
	["BrokenVisualOneTime"] = "О поломке один раз",
	["OriginalIMBF"] = "Заменить панель талисманов",
	["EquipNew"] = "Заменять талисманы",
	["DurableVisible"] = "Прочность визуально",
};

MR_STATE_NORMAL = 0;
MR_STATE_WARNING = 1;
MR_STATE_DISABLED = 2;

function MR.ui.SetState( _state )
	local normalTexture = MRMinimapButton:GetNormalTexture();
	local pushedTexture = MRMinimapButton:GetPushedTexture();
	if( _state == MR_STATE_NORMAL )then
		normalTexture:SetTexture( "Interface/AddOns/mRepair/minimap" );
		pushedTexture:SetTexture( "Interface/AddOns/mRepair/minimap" );
	elseif( _state == MR_STATE_WARNING )then
		normalTexture:SetTexture( "Interface/AddOns/mRepair/minimap-warn" );
		pushedTexture:SetTexture( "Interface/AddOns/mRepair/minimap-warn" );
	else
		normalTexture:SetTexture( "Interface/AddOns/mRepair/minimap-disabled" );
		pushedTexture:SetTexture( "Interface/AddOns/mRepair/minimap-disabled" );
	end;
end;

function MR.ui.ShowHint( this )
	MLib.TT.Init( this, MR.Name .. " " .. MR.Version, 300, "ANCHOR_BOTTOMRIGHT", 0, 0 );
	
	MLib.TT.Space();
	if( mRepairVariables.Enabled )then
		MLib.TT.Line( "   " .. MLib.YESPattern:format( "ВКЛЮЧЕН!" ) );
	else
		MLib.TT.Line( "   " .. MLib.NOPattern:format( "ВЫКЛЮЧЕН" ) );
	end;
	MLib.TT.Space();

	if( mRepairVariables.Broken )then
		MLib.TT.Line( "   " .. MR.ui.Vars.Broken .. " " .. MLib.YESPattern:format( "Да" ) );
	else
		MLib.TT.Line( "   " .. MR.ui.Vars.Broken .. " " .. MLib.NOPattern:format( "Нет" ) );
	end;

	if( mRepairVariables.BrokenChats )then
		MLib.TT.Line( "   " .. MR.ui.Vars.BrokenChats .. " " .. MLib.YESPattern:format( "Да" ) );
	else
		MLib.TT.Line( "   " .. MR.ui.Vars.BrokenChats .. " " .. MLib.NOPattern:format( "Нет" ) );
	end;

	MLib.TT.Line( "   Интервал сообщений " .. tostring( mRepairVariables.MessageDelay ) .. " сек" );

	if( mRepairVariables.BrokenVisual )then
		MLib.TT.Line( "   " .. MR.ui.Vars.BrokenVisual .. " " .. MLib.YESPattern:format( "Да" ) );
	else
		MLib.TT.Line( "   " .. MR.ui.Vars.BrokenVisual .. " " .. MLib.NOPattern:format( "Нет" ) );
	end;

	if( mRepairVariables.Talismans )then
		MLib.TT.Line( "   " .. MR.ui.Vars.Talismans .. " " .. MLib.YESPattern:format( "Да" ) );
	else
		MLib.TT.Line( "   " .. MR.ui.Vars.Talismans .. " " .. MLib.NOPattern:format( "Нет" ) );
	end;
	
	if( mRepairVariables.BrokenVisualOneTime )then
		MLib.TT.Line( "   " .. MR.ui.Vars.BrokenVisualOneTime .. " " .. MLib.YESPattern:format( "Да" ) );
	else
		MLib.TT.Line( "   " .. MR.ui.Vars.BrokenVisualOneTime .. " " .. MLib.NOPattern:format( "Нет" ) );
	end;
	
	if( mRepairVariables.OriginalIMBF )then
		MLib.TT.Line( "   " .. MR.ui.Vars.OriginalIMBF .. " " .. MLib.YESPattern:format( "Да" ) );
	else
		MLib.TT.Line( "   " .. MR.ui.Vars.OriginalIMBF .. " " .. MLib.NOPattern:format( "Нет" ) );
	end;
	
	if( mRepairVariables.EquipNew )then
		MLib.TT.Line( "   " .. MR.ui.Vars.EquipNew .. " " .. MLib.YESPattern:format( "Да" ) );
	else
		MLib.TT.Line( "   " .. MR.ui.Vars.EquipNew .. " " .. MLib.NOPattern:format( "Нет" ) );
	end;
	
	MLib.TT.Line( "   Критическая прочность " .. tostring( mRepairVariables.CriticalDurable ) );
	MLib.TT.Line( "   Критическое различие " .. tostring( mRepairVariables.CriticalPrecent ) .. "% прочн." );
	
	MLib.TT.Space();
	MLib.TT.Line( "Левая кнопка мыши окно настроек", 0, 0.75, 0.95 );
	MLib.TT.Line( UI_MINIMAPBUTTON_MOVE, 0, 0.75, 0.95 );
end;

function MR.ui.OptionsMenu()
	local info = {}
	if UIDROPDOWNMENU_MENU_LEVEL == 1 then
		info = {}
		info.text = MR.ui.Vars.Enabled
		info.checked = mRepairVariables.Enabled
		info.func = function() mRepairVariables.Enabled = not mRepairVariables.Enabled; end;
		info.value = 1
		UIDropDownMenu_AddButton(info, 1)

		info = {}
		info.text = MR.ui.Vars.Broken
		info.checked = mRepairVariables.Broken
		info.func = function() mRepairVariables.Broken = not mRepairVariables.Broken; end;
		info.value = 2
		UIDropDownMenu_AddButton(info, 1)

		info = {}
		info.text = MR.ui.Vars.BrokenVisual
		info.checked = mRepairVariables.BrokenVisual
		info.func = function() mRepairVariables.BrokenVisual = not mRepairVariables.BrokenVisual; end;
		info.value = 3
		UIDropDownMenu_AddButton(info, 1)

		info = {}
		info.text = MR.ui.Vars.Talismans
		info.checked = mRepairVariables.Talismans
		info.func = function() mRepairVariables.Talismans = not mRepairVariables.Talismans; end;
		info.value = 4
		UIDropDownMenu_AddButton(info, 1)

		info = {}
		info.text = MR.ui.Vars.BrokenVisualOneTime
		info.checked = mRepairVariables.BrokenVisualOneTime
		info.func = function() mRepairVariables.BrokenVisualOneTime = not mRepairVariables.BrokenVisualOneTime; end;
		info.value = 4
		UIDropDownMenu_AddButton(info, 1)
		
		info = {}
		info.text = MR.ui.Vars.OriginalIMBF
		info.checked = mRepairVariables.OriginalIMBF
		info.func = function() mRepairVariables.OriginalIMBF = not mRepairVariables.OriginalIMBF; MR.ui.ReplaceIMBFSlots(); end;
		info.value = 4
		UIDropDownMenu_AddButton(info, 1)
		
		info = {}
		info.text = MR.ui.Vars.EquipNew
		info.checked = mRepairVariables.EquipNew
		info.func = function() mRepairVariables.EquipNew = not mRepairVariables.EquipNew; end;
		info.value = 4
		UIDropDownMenu_AddButton(info, 1)
		
		info = {}
		info.text = MR.ui.Vars.DurableVisible
		info.checked = mRepairVariables.DurableFrame.Enable
		info.func = function() mRepairVariables.DurableFrame.Enable = not mRepairVariables.DurableFrame.Enable; end;
		info.value = 4
		UIDropDownMenu_AddButton(info, 1)

		info = {}
		info.text = ""
		info.checked = false
		info.func = function() end;
		info.value = 5
		UIDropDownMenu_AddButton(info, 1)

		info = {}
		info.text = "Настройки"
		info.checked = false
		info.func = function() MR.ui.ShowConfig(); end;
		info.value = 6
		UIDropDownMenu_AddButton(info, 1)
	end;
end;

function MR.ui.ShowBrokens()
	local chats = 1;
	if( mRepairVariables.BrokenChats )then chats = 10; end;
	for n = 1, #MR.Brokens do
	
		local _item = MR.Brokens[ n ];
		if( not _item["empty"] )then
			if( _item["curr"] <= mRepairVariables.CriticalDurable * 100 )then
		
				MR.Message( MR.BrokenMessage:format( _item["name"] ), chats );
				
			elseif( _item["percent"] <= mRepairVariables.CriticalPrecent )then
				
				MR.Message( _item["name"] .. MLib.PercentFormat( _item["percent"], " в критическом состоянии!" ), chats );
				
			end;
		end;
		
	end;
end;

function MR.ui.ShowConfig()
	if( MRConfig:IsVisible() )then
		MRConfig:Hide();
	else
		MRConfig:Show();
	end;
end;

function MR.ui.ConfigOnLoad( this )
	UIPanelBackdropFrame_SetTexture( this, "Interface/Common/PanelCommonFrame", 256 , 256 );
end;

function MR.ui.ConfigOnShow( this )
	MRConfigTitle:SetText( MR.Name .. " " .. MR.Version .. " настройки" );
	MRConfig_chkEnabled:SetChecked( mRepairVariables.Enabled );
	MRConfig_chkEnabled_Text:SetText( "Аддон включен" );
	MRConfig_chkBroken:SetChecked( mRepairVariables.Broken );
	MRConfig_chkBroken_Text:SetText( "Сообщения в чат о поломках" );
	MRConfig_chkBrokenChats:SetChecked( mRepairVariables.BrokenChats );
	MRConfig_chkBrokenChats_Text:SetText( "Сообщение о поломках во все чаты (выкл - только в общий)" );
	MRConfig_DelayDesc:SetText( "Интервал вывода сообщений о поломках в чат (в секундах)" );
	MRConfig_Delay:SetValueStepMode("INT");
	MRConfig_Delay:SetMinMaxValues( 10, 120 );
	MRConfig_DelayLow:SetText("10");
	MRConfig_DelayHigh:SetText("120")
	MRConfig_Delay:SetValue( mRepairVariables.MessageDelay );
	MRConfig_DelayValue:ClearAllAnchors();
	MRConfig_DelayValue:SetAnchor( "TOPLEFT", "TOPRIGHT", MRConfig_Delay, 7, 1 );
	MRConfig_chkVisualBroken:SetChecked( mRepairVariables.BrokenVisual );
	MRConfig_chkVisualBroken_Text:SetText( "Визуализированное сообщение о поломках" );
	MRConfig_chkTalismans:SetChecked( mRepairVariables.Talismans );
	MRConfig_chkTalismans_Text:SetText( "Визуализированное сообщение о наполнении талисманов" );
	
	MRConfig_label1:SetText( "Критическая прочность вещей" );
	MRConfig_label2:SetText( "Критическая различие прочности" );
	
	MRConfig_edtCD:SetText( mRepairVariables.CriticalDurable );
	MRConfig_edtCP:SetText( mRepairVariables.CriticalPrecent );
	
	MRConfig_SaveButton:SetText( "Сохранить" );
	
	_G[ "MRConfigHammer" .. "Icon" ]:SetTexture( mRepairVariables.Hammer.icon );
	local r, g, b = MLib.ColorHex2Dec( MLib.Qualities[ mRepairVariables.Hammer.quality ]:sub( 5, 10 ) );
	_G[ "MRConfigHammer" .. "Quality" ]:Show();
	_G[ "MRConfigHammer" .. "Quality" ]:SetColor( r, g, b );
	_G[ "MRConfigHammer" .. "Text" ]:SetText( mRepairVariables.Hammer.name );
end;

function MR.ui.DelayOnValueChanged( this )
	GCF_Slider_OnValueChanged( this );
end;

function MR.ui.SaveProperties()
	mRepairVariables.Enabled = MRConfig_chkEnabled:IsChecked();
	mRepairVariables.Broken = MRConfig_chkBroken:IsChecked();
	mRepairVariables.BrokenChats = MRConfig_chkBrokenChats:IsChecked();
	mRepairVariables.MessageDelay = MRConfig_Delay:GetValue();
	mRepairVariables.BrokenVisual = MRConfig_chkVisualBroken:IsChecked();
	mRepairVariables.Talismans = MRConfig_chkTalismans:IsChecked();
	
	mRepairVariables.CriticalDurable = tonumber( MRConfig_edtCD:GetText() );
	mRepairVariables.CriticalPrecent = tonumber( MRConfig_edtCP:GetText() );
	
	mRepairVariables.Hammer = MRConfig.Hammer;
	
	SaveVariables( "mRepairVariables" );
	
	MRConfig:Hide();
end;


function MR.ui.ReplaceIMBFSlots()
	if( not mRepairVariables.OriginalIMBF )then
		for n = 0, 2 do
			_G[ "IMBF_Talisman" .. n .. "Slot" ]:Show();
		end;
		MRTalismans:Hide();
	else
		for n = 0, 2 do
			_G[ "IMBF_Talisman" .. n .. "Slot" ]:Hide();
		end;
		MRTalismans:Show();
	end;
end;

function MR.ui.TalismanRefresh( id )
	local _eqID = GetInventorySlotInfo( "Talisman" .. id .. "Slot" );
	local _,_,itemName,durableValuef,durableMaxf = GetInventoryItemDurable( "player", _eqID );
	
	if( itemName == nil )then
	
		_G[ "MRTalismans_Talisman" .. id ]:Hide();
		
	else
		
		_G[ "MRTalismans_Talisman" .. id ]:Show();
		
		local _percent = math.floor( durableValuef * 100 / durableMaxf );
		local r, g, b = MLib.ColorHex2Dec( MLib.PercentColor( _percent ) );
		_G[ "MRTalismans_Talisman" .. id .. "StatusBar" ]:SetBarColor( r, g, b, 1 );
		_G[ "MRTalismans_Talisman" .. id .. "StatusBar" ]:SetValue( _percent );
		_G[ "MRTalismans_Talisman" .. id .. "StatusBar" ]:SetWidth( mRepairVariables.TalismansWidth );
		_G[ "MRTalismans_Talisman" .. id .. "StatusBarStringsName" ]:SetText( itemName );
		_G[ "MRTalismans_Talisman" .. id .. "StatusBarStringsData" ]:SetText( MLib.PercentFormat( _percent, _percent .. "%" ) );
		
		local _texture = GetInventoryItemTexture( "player", _eqID );
		_G[ "MRTalismans_Talisman" .. id .. "Texture" ]:ClearAllAnchors();
		_G[ "MRTalismans_Talisman" .. id .. "Texture" ]:SetAnchor( "TOPLEFT", "TOPLEFT", _G[ "MRTalismans_Talisman" .. id ], 7, 7 );
		_G[ "MRTalismans_Talisman" .. id .. "Texture" ]:SetWidth( 18 );
		_G[ "MRTalismans_Talisman" .. id .. "Texture" ]:SetHeight( 18 );
		_G[ "MRTalismans_Talisman" .. id .. "Texture" ]:SetTexture( _texture );
		
		_G[ "MRTalismans_Talisman" .. id ]:SetID( _eqID );
		
	end;
end;

function MR.ui.MRTalismansOnUpdate( this, elapsedTime )
	for n = 0, 2 do
		MR.ui.TalismanRefresh( n );
	end;
	MR.ui.ReplaceIMBFSlots();
	
	if( MRTalismans:GetID() ~= 0 )then
		PickupEquipmentItem( MRTalismans:GetID() );
		if( CursorItemType() == nil )then 
			MRTalismans:SetID( 0 );
		end;
	end;
	
	if( mRepairVariables.DurableFrame.Enable )then
		MRVisualDurable:Show();
	else
		MRVisualDurable:Hide();
	end;
end;

function MR.ui.EquipDurabilityOnUpdate( this, elapsedTime )
	if( this.Time == nil )then this.Time = 0; end;
	this.Time = this.Time + elapsedTime;
	if( this.Time < 0.5 )then return nil; end;
	this.Time = 0;
	
	local index = this:GetID();
	local curr, max = GetInventoryItemDurable( "player", index );
	if( max == 0 )then
		_G[ this:GetName() .. "Text" ]:SetText( "" );
		return nil;
	end;
	local percent = math.floor( curr * 100 / max );
	
	if( max > 100 )then
		max = MR.HighDurable:format( max );
	else
		max = MR.NormDurable:format( max );
	end;
	local current = "";
	if( curr > 100 )then
		current = MR.HighDurable:format( curr );
	else
		current = MR.NormDurable:format( curr );
	end;
	if( percent < 50 )then current = MR.LowDurable:format( curr ); end;
	if( percent < 20 )then current = MR.CritDurable:format( curr ); end;

	if( this.IsPlaced == nil )then
		this.IsPlaced = true;
		this:ClearAllAnchors();
		this:SetAnchor( "TOPLEFT", "BOTTOMLEFT", "$parent", 0, -5 );
		this:SetAnchor( "BOTTOMRIGHT", "BOTTOMRIGHT", "$parent", 0, 5 );
	end;
	_G[ this:GetName() .. "Text" ]:SetText( "" );
	_G[ this:GetName() .. "Text" ]:SetFontSize( 9 );
	_G[ this:GetName() .. "Text" ]:SetText( current .. "/" .. max );
end;

function MR.ui.EquipDurabilityVisualHint( this )
	if( not MRVisualDurable:IsVisible() )then return nil; end;
	GameTooltip:SetOwner( this, "ANCHOR_TOPRIGHT", -10, 0 );
	GameTooltip:SetInventoryItem( "player", this:GetID() );
end;

function MR.ui.EquipDurabilityVisualOnUpdate( this, elapsedTime )
	if( not MRVisualDurable:IsVisible() )then return nil; end;
	if( this.Time == nil )then this.Time = 0; end;
	this.Time = this.Time + elapsedTime;
	if( this.Time < 1 )then return nil; end;
	this.Time = 0;
	
	_G[ this:GetName() .. "Icon" ]:SetTexture( GetInventoryItemTexture( "player", this:GetID() ) );
	local quality = GetInventoryItemQuality( "player", this:GetID() );
	local r, g, b = MLib.ColorHex2Dec( MLib.Qualities[ quality ]:sub( 5, 10 ) );
	if( quality > 0 )then
		_G[ this:GetName() .. "Quality" ]:SetColor( r, g, b );
		_G[ this:GetName() .. "Quality" ]:Show();
	else
		_G[ this:GetName() .. "Quality" ]:Hide();
	end;
	
	local index = this:GetID();
	local curr, max = GetInventoryItemDurable( "player", index );
	if( max == 0 )then
		_G[ this:GetName() .. "Text" ]:SetText( "" );
		return nil;
	end;
	local percent = math.floor( curr * 100 / max );
	
	if( max > 100 )then
		max = MR.HighDurable:format( max );
	else
		max = MR.NormDurable:format( max );
	end;
	local current = "";
	if( curr > 100 )then
		current = MR.HighDurable:format( curr );
	else
		current = MR.NormDurable:format( curr );
	end;
	if( percent < 50 )then current = MR.LowDurable:format( curr ); end;
	if( percent < 20 )then current = MR.CritDurable:format( curr ); end;

	_G[ this:GetName() .. "Text" ]:SetText( "" );
	_G[ this:GetName() .. "Text" ]:SetFontSize( 9 );
	_G[ this:GetName() .. "Text" ]:SetText( current .. "/" .. max );
end;

--[[ /run dofile("Interface/AddOns/mRepair/code/ui.lua"); ]]